#include<stdio.h>
#include<math.h>
#include"SimpleImage.h"
#include"pgmio.h"


/* Defining Numerical Approximation of PI */
#define PI 3.141592653589793238462643383279502884197
/* End Defining Numerical Approximation of PI */


/*************************/
int getImage_Coordinate(int val,double v){
  int di = ((int)(v));if(fabs(v-di)>0.5)di++;
  if(di<0)di=0;if(di>val-1)di=val-1;
  return di;
}
double size(double v1[2]){
  double dx = v1[0];
  double dy = v1[1];
  return sqrt((dx*dx+dy*dy));
}
double dist(double v1[2],double v2[2]){
  double vec[2];
  vec[0] = v1[0]-v2[0];
  vec[1] = v1[1]-v2[1];
  return size(vec);
}

#include"interpolation.h"

/*************************/
/* Start */


void AffineTransformation_FW(double inX[2],double A[2][2],double t[2],double outX[2]){
  
}
void Translate(double inX[2],double t[2],double outX[2]){
  

}
void Scaling(double A[2][2],double xfac,double yfac){
  

}
void Shearing(double A[2][2],double xfac,double yfac){
  

} 
void Line_Inversion(double A[2][2],double mxy[2]){
  

}
void Rotation(double A[2][2],double theta){
  

}

void AffineTransformation_FW(double inX[2],double A[2][2],double t[2],double ci[2],double co[2],double outX[2]){
  
  
  
}
double Determinant(double A[2][2]){
  return A[0][0]*A[1][1]-A[0][1]*A[1][0];
}
void Vector_Matrix_Multiplication_Inverse(double inX[2],double A[2][2],double outX[2]){
  double det = Determinant(A);
  if(det==0.0){
    printf("Warning !; your matrix A does not have an inverse matrix !\n");
    det =1.0;
  }
  
  outX[0] = (A[1][1]*inX[0]-A[0][1]*inX[1])/det;
  outX[1] = (-A[1][0]*inX[0]+A[0][0]*inX[1])/det;
}
void AffineTransformation_BW(double inX[2],double A[2][2],double t[2],double ci[2],double co[2],double outX[2]){
    
  
  
}

/* End */
/***********************/
/* Estimating Size: */
void setNewSize(int sx,int sy,double A[2][2],double t[2],double new_size[2]){
  double q[4][2];
  q[0][0] = 0.0;q[0][1] = 0.0;
  q[1][0] = ((double)(sx));q[1][1] = 0.0;
  q[2][0] = 0.0;q[2][1] = ((double)(sy));
  q[3][0] = ((double)(sx));q[3][1] = ((double)(sy));
  double p[4][2];
  AffineTransformation_FW(q[0],A,t,p[0]);
  AffineTransformation_FW(q[1],A,t,p[1]);
  AffineTransformation_FW(q[2],A,t,p[2]);
  AffineTransformation_FW(q[3],A,t,p[3]);
  double minX,maxX,minY,maxY;
  minX = maxX = p[0][0];
  minY = maxY = p[0][1];
  int i;
  for(i=1;i<4;i++){
    if(maxX<p[i][0])maxX=p[i][0];
    if(minX>p[i][0])minX=p[i][0];
    if(maxY<p[i][1])maxY=p[i][1];
    if(minY>p[i][1])minY=p[i][1];
  }
  new_size[0] = fabs(maxX-minX)+fabs(t[0]);
  new_size[1] = fabs(maxY-minY)+fabs(t[1]);
}
/*************************/

/* 
   g++ -o ex02_0 ex02_0.cxx -lm

./ex02_0 lena.pgm test_ex02_0.pgm

*/
int main(int argc,char *argv[]){
  
  /* file I/O */
  Image *in = new Image();
  getPGM(in,argv[1]);
  /* end file I/O */

 

  /* main processing */
  int i,j;
  
  
  /* Transformation Matrix and Vector */
  double A[2][2];
  A[0][0] = 1.0; A[1][0] = 0.0;
  A[0][1] = 0.0; A[1][1] = 1.0;
  

  double t[2];
  t[0] = 0.0; t[1] = 0.0;
  
  /* Coordinates */
  double inX[2];
  double outX[2];
  
  /* Image Size after Transformation */
  double new_size[2];
  setNewSize(in->sx,in->sy,A,t,new_size);
  double centerIn[2];
  centerIn[0] = ((double)(in->sx))*0.5;
  centerIn[1] = ((double)(in->sy))*0.5;

  /* Output Image */
  Image *out = new Image(new_size[0],new_size[1]);
  printf("Old Size (%d,%d) to New Size: (%d,%d)\n",in->sx,in->sy,out->sx,out->sy);
  double centerOut[2];
  centerOut[0] = 0.5*(((double)(out->sx))-t[0]);
  centerOut[1] = 0.5*(((double)(out->sy))-t[1]);
  
  
  /* Input Zero Value */
  for(i=0;i<out->sy;i++)
    for(j=0;j<out->sx;j++){
      out->img[i][j] = 0.0;
      
    }
  
  
  /* Forward Mapping */
  
  /* end main processing */


  savePGM(out,argv[2]);
  delete out;  
  delete in;
  return 0;
}

