#include<stdio.h>
#include<math.h>
#include"SimpleImage.h"
#include"ppmio.h"
#include"affine.h"



int main(int argc,char *argv[]){
  if(argc!=3){
    printf("Please use as ./a.out input.ppm output.pgm\n");
    return 0;
  }

  /* file I/O */
  Image *inR = new Image();
  Image *inG = new Image();
  Image *inB = new Image();

  getPPM(inR,inG,inB,argv[1]);
  
  
  /* end file I/O */

 

  /* main processing */
  int i,j;
  
  
  /* Transformation Matrix */
  double A[2][2];

  // Test Scaling
  double X_Scaling_Factor=5.0;
  double Y_Scaling_Factor=5.0;
  Scaling(A,X_Scaling_Factor,Y_Scaling_Factor);

  // Test Shearing
  double X_Shearing_Factor=0.5;
  double Y_Shearing_Factor=1.0;
  //Shearing(A,X_Shearing_Factor,Y_Shearing_Factor);
    
  // Test Rotation
  double Rotation_Angle = 45.0;
  //Rotation(A,Rotation_Angle);
  
  // Test line inversion (Reflection)
  double LIVector[2];LIVector[0]=1.0;LIVector[1]=1.5;
  //Line_Inversion(A,LIVector);


  /* Translation Vector */
  double t[2];
  
  t[0]=t[1]=0.0;// no translation
  
  /* Set New Image Size*/
  double new_size[2];
  setNewSize(inR->sx,inR->sy,A,t,new_size);
  
  double centerIn[2];
  centerIn[0] = ((double)(inR->sx))*0.5;
  centerIn[1] = ((double)(inR->sy))*0.5;
  
  

    
  Image *outR = new Image(((int)(new_size[0])),((int)(new_size[1])));
  Image *outG = new Image(((int)(new_size[0])),((int)(new_size[1])));
  Image *outB = new Image(((int)(new_size[0])),((int)(new_size[1])));
   double centerOut[2];
   
   centerOut[0] = 0.5*(((double)(outR->sx))-t[0]);
   centerOut[1] = 0.5*(((double)(outR->sy))-t[1]);
  
  printf("Old Size (%d,%d) to New Size: (%d,%d)\n",inR->sx,inR->sy,outR->sx,outR->sy);
  
  
  /* Input Zero Value */
  for(i=0;i<outR->sy;i++)
    for(j=0;j<outR->sx;j++){
      outR->img[i][j] = 0.0;
      outG->img[i][j] = 0.0;
      outB->img[i][j] = 0.0;
    }
  
  
  /* Forward Mapping */
  double uv[2],xy[2];
  for(i=0;i<inR->sy;i++){
    uv[1] = ((double)(i));
    for(j=0;j<inR->sx;j++){
      uv[0] = ((double)(j));
      //AffineTransformation_FW(uv,A,t,xy);
      AffineTransformation_FW(uv,A,t,centerIn,centerOut,xy);
      int out_i =  getImage_Coordinate(outR->sy,xy[1]);
      int out_j =  getImage_Coordinate(outR->sx,xy[0]);
      
      
      outR->img[out_i][out_j] = inR->img[i][j];
      outG->img[out_i][out_j] = inG->img[i][j];
      outB->img[out_i][out_j] = inB->img[i][j];
      
    }
  }
  	    

  /* end main processing */


   savePPM(outR,outG,outB,argv[2]);

  delete outR;
  delete outG;
  delete outB;
  
  delete inR;
  delete inG;
  delete inB;
  
  return 0;
}
